/* /////////////////////////////////////////////////////////////////////////////
 * File:        unittest.cpp
 *
 * Purpose:		Unit test file for ATLSTL
 *
 * Created:		11th April 2004
 * Updated:     15th December 2005
 *
 * Author:      Matthew Wilson
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2002. All rights reserved.
 *
 * Home:        www.stlsoft.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


// Must define this
#ifndef STLSOFT_UNITTEST
# error This file cannot be used if STLSOFT_UNITTEST is not defined.
#endif /* !STLSOFT_UNITTEST */

#if defined(__MWERKS__)
# if defined(_STLSOFT_COMPILE_VERBOSE)
#  undef _STLSOFT_COMPILE_VERBOSE
# endif /* _STLSOFT_COMPILE_VERBOSE */
#endif /* __MWERKS__ */

#ifdef __BORLANDC__
# pragma warn -8008
# pragma warn -8066
#endif /* __BORLANDC__ */

#include <stdio.h>
#include <atlstl/atlstl.hpp>
#include <unittest/simple_unittester.h>
#if defined(__STLSOFT_COMPILER_IS_DMC)
# include <crtdbg.h>
# include <stdarg.h>
# include <malloc.h>
#endif /* __STLSOFT_COMPILER_IS_DMC */

#ifdef __BORLANDC__
# pragma warn -8013
# pragma warn -8084
#endif /* __BORLANDC__ */

#if defined(__INTEL_COMPILER)
# pragma warning(disable : 1419)
#endif /* __INTEL_COMPILER */

#if defined(__STLSOFT_COMPILER_IS_INTEL)
# if !defined(__MWERKS__)
#  define __MWERKS__	(0)
# endif /* !__MWERKS__ */
# if !defined(__DMC__)
#  define __DMC__	(0)
# endif /* !__DMC__ */
#endif /* !__STLSOFT_COMPILER_IS_MSVC */

////////////////////////////////////////////////////////////////////////////////

CComModule _Module;

////////////////////////////////////////////////////////////////////////////////
// main

//extern "C" void __stdcall Sleep(unsigned long);

int main(int argc, char **argv)
{
//	Sleep(100000);

	int		i;
	bool	bVerbose	=	false;

	for(i = 1; i < argc; ++i)
	{
		if(	0 == strcmp(argv[i], "-v") ||
			0 == strcmp(argv[i], "-verbose"))
		{
			bVerbose = true;
		}
	}

	puts("Running ATLSTL unittests");

#if defined(__STLSOFT_COMPILER_IS_DMC)
	atlstl_message_assert("Arse", 1);
#endif /* __STLSOFT_COMPILER_IS_DMC */

	return !::stlsoft::unittest::simple_unittest_host::get_host()->test(bVerbose);
}

////////////////////////////////////////////////////////////////////////////////

#if _ATL_VER < 0x0700
# include <atlimpl.cpp>
#endif /* _ATL_VER */

////////////////////////////////////////////////////////////////////////////////

#if defined(__STLSOFT_COMPILER_IS_DMC)
_CRTIMP int __cdecl _CrtDbgReport(	int			reportType
								,	const char	*filename
								,	int			linenumber
								,	const char	*moduleName
								,	const char	*format
								,	...)
{
	va_list	args;

	va_start(args, format);

	char	*msg	=	(char*)_alloca(10000);

	vsprintf(msg, format, args);

	fprintf(stderr, "%s(%d): Assertion: %s\n", filename, linenumber, msg);
	fflush(stderr);

	ExitProcess(EXIT_FAILURE);

	va_end(args);

	return -1;
}
#endif /* __STLSOFT_COMPILER_IS_DMC */

////////////////////////////////////////////////////////////////////////////////
